%define kernel_version 2.6.18
%define kernel_release 238.9.1.el5
%define kernel_fullname %{kernel_version}-%{kernel_release}

%define perl_version      5.8.8
%define perl_prefix       /usr/lib64/perl5
%define perl_arch         x86_64-linux-thread-multi
%define global_perl       %{perl_prefix}/lib/%{perl_version}
%define global_perl_arch  %{global_perl}/%{perl_arch}
%define site_perl         %{perl_prefix}/site_perl/%{perl_version}
%define site_perl_arch    %{site_perl}/%{perl_arch}
%define perl_binary       %{perl_prefix}/bin/perl



Summary: PF_RING is a new type of network socket that dramatically improves the packet capture speed
Name: pfring
Version: 4.6.1.r4527
Release: 7.ru
License: GPL
Group: Other
Source0: pf_ring-4.6.1.tar.gz
Patch0: lib_makefile.patch
URL: http://www.ntop.org/PF_RING.html
BuildRoot: %{_tmppath}/%{name}-root
BuildRequires: kernel-devel = 2.6.18-238.9.1.el5
BuildRequires: kernel
BuildRequires: bison gcc-c++ libtool automake autoconf flex
BuildRequires: perl = %{perl_version}
Requires: kernel = %{kernel_version}
Conflicts: libpcap
#Provides: libpcap

%description

%prep
%setup -q -n PF_RING
# patch kernel makefile to use the correct path to headers
sed -i 's|/usr/src/linux-headers-%{kernel_fullname}|/usr/src/kernels/%{kernel_fullname}|g' kernel/Makefile
sed -i 's|cd $(E1000E)|#cd $(E1000E)|' drivers/intel/Makefile
#patch lib makefile so we can install to destdir instead of /
%patch0 -p0 
cp userland/lib/Makefile /tmp/Makefile

%build
echo "JAREK1"
make
echo "JAREK2"

%install

mkdir -p $RPM_BUILD_ROOT/usr/src/linux-headers-%{kernel_fullname}/include/linux


cd kernel
make DESTDIR="$RPM_BUILD_ROOT" install
cd ..

cd drivers
#make DESTDIR="$RPM_BUILD_ROOT" install
cd ..

cd legacy
#make DESTDIR="$RPM_BUILD_ROOT" install
cd ..

userland_paths=(libpcap-1.1.1-ring perl/Net-Pfring tcpdump-4.1.1 lib )

cp /tmp/Makefile userland/lib/Makefile

# don't ldconfig now, we'll do it later in postinstall
sed -i 's|ldconfig||' userland/lib/Makefile

cd userland
for path in ${userland_paths[@]}; do
	pushd .
	cd $path
	make DESTDIR="$RPM_BUILD_ROOT"  install
	popd
done

#we have to treat examples a little special
cd examples
make
#examples don't have a "make install", so copy all executable files to /usr/local/bin
find . -perm +111 -type f  -exec cp {} "$RPM_BUILD_ROOT"/usr/local/bin/ \;
cd ..
cd ..



rm "$RPM_BUILD_ROOT"/%{perl_prefix}/%{perl_version}/%{perl_arch}/perllocal.pod
rm "$RPM_BUILD_ROOT"/%{site_perl_arch}/auto/Net/Pfring/.packlist
mkdir /tmp/manpages
mv "$RPM_BUILD_ROOT"/usr/share/man/man3/* /tmp/manpages
mv "$RPM_BUILD_ROOT"/usr/local/share/man/* "$RPM_BUILD_ROOT"/usr/share/man/
mv /tmp/manpages/* "$RPM_BUILD_ROOT"/usr/share/man/man3/

%clean
rm -rf %{buildroot}

%post 
echo "/usr/local/lib" >> /etc/ld.so.conf
ldconfig

%postun 

%files 
%defattr(-, root, root)
/lib/modules/%{kernel_fullname}/kernel/net/pf_ring/pf_ring.ko
%{site_perl_arch}/Net/Pfring.pm
%{site_perl_arch}/auto/Net/Pfring/*
/usr/local/bin/pcap-config
/usr/local/include/pcap-bpf.h
/usr/local/include/pcap-namedb.h
/usr/local/include/pcap.h
/usr/local/include/pcap/*
/usr/local/include/pfring.h
/usr/local/include/pfring_e1000e_dna.h
/usr/local/lib/libpfring.a
/usr/local/lib/libpfring.so
/usr/local/lib/libpcap.*
/usr/local/sbin/tcpdump
/usr/local/sbin/tcpdump.4.1.1
/usr/share/man/man1/pcap*
/usr/share/man/man1/tcpdump.1*
/usr/share/man/man3/pcap*
/usr/share/man/man5/pcap*
/usr/share/man/man7/pcap*
/usr/share/man/man3/Net::Pfring.3pm.gz
/usr/src/linux-headers-%{kernel_fullname}/include/linux/pf_ring.h

#examples 
/usr/local/bin/alldevs
/usr/local/bin/dummy_plugin_pfcount
/usr/local/bin/forwarder
/usr/local/bin/pcap2nspcap
/usr/local/bin/pcaps
/usr/local/bin/pcount
/usr/local/bin/pfbounce
/usr/local/bin/pfcount
/usr/local/bin/pfcount_dummy_plugin
/usr/local/bin/pfcount_multichannel
/usr/local/bin/pffilter_test
/usr/local/bin/pfmap
/usr/local/bin/pftwin
/usr/local/bin/preflect
/usr/local/bin/ptwin
/usr/local/bin/pwrite
/usr/local/bin/ringc
/usr/local/bin/ringm
/usr/local/bin/rings


%changelog
* Tue Apr 26 2011 Jarek Sedlacek <jarek@nbcs.rutgers.edu> - 4.6.1-r527-7.ru
- built examples and installed to /usr/local/bin
* Wed Apr 20 2011 Jarek Sedlacek <jarek@nbcs.rutgers.edu> - 4.6.1-r527-6.ru
- built against kernel 2.6.18-238.9.1.el5
* Tue Apr 05 2011 Jarek Sedlacek <jarek@nbcs.rutgers.edu> - 4.6.1-r527-4.ru
- added lib files, moved man pages to correct spot
* Wed Mar 23 2011 Jarek Sedlacek <jarek@nbcs.rutgers.edu> - 4.6.1-r4527-3.ru
- fixed depends/provides
* Wed Mar 23 2011 Jarek Sedlacek <jarek@nbcs.rutgers.edu> - 4.6.1-r4527-1.ru
- Initial Build
